# -*- coding: utf-8 -*-
from enigma import *
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from twisted.internet import reactor
from twisted.web2 import server, channel, static, resource, stream, http_headers, responsecode, http
from enigma import eConsoleAppContainer

import os
import gettext
from os import statvfs
barryallen_path = "/media/ba"
barryallen_plugindir="/usr/lib/enigma2/python/Plugins/Extensions/BarryAllen" 
barryallen_localedir="%s/locale" % barryallen_path
barryallen_language = "%s/.balanguage"  % barryallen_plugindir
barryallen_locked = "%s/.balocked" % barryallen_path
barryallen_imagelist = "/tmp/.baimages"
barryallen_downloads = "/tmp/.badownloads"
usr_script = "/usr/script"
barryallen_usr_script = "%s/script" % barryallen_path

os.environ['LANGUAGE']='en'
ba_language='en'

if os.path.exists("/etc/enigma2/settings") == True:
   f = open("/etc/enigma2/settings")
   line = f.readline()
   while (line):
	line = f.readline().replace("\n","")
	sp = line.split("=")
	if (sp[0] == "config.osd.language"):
	   sp2 = sp[1].split("_")
           ba_language = sp2[0]
           if os.path.exists("%s/%s" % (barryallen_localedir, ba_language)) == True:
              os.environ["LANGUAGE"] = sp[1]
           else:
              os.environ['LANGUAGE']='en'
              ba_language='en'

   f.close


if os.path.exists("/media/ba/locale") == True:
   _=gettext.Catalog('barryallen', '/media/ba/locale').gettext
if os.path.exists("%s/locale" % barryallen_plugindir) == True:
   _=gettext.Catalog('barryallen', barryallen_plugindir).gettext
      
###############################################################################
# CONFIG
###############################################################################

# versionstring, please do not change, if you do not release a new version
barryallen_version = "4.6.88"
enigma_version="Enigma2"

# path to the standard readme-file
barryallen_readme = "%s/readme.txt" % barryallen_plugindir

# path to the barryallen.sh
barryallen_script = "%s/ba.sh" % barryallen_path

# path to the tmpfiles
barryallen_tmpfile = "/tmp/.batmp" 

# name of the MB image file
barryallen_mbimagepath = "/MB_Images"
if os.path.exists(barryallen_mbimagepath) == False:
   if (os.path.exists("/media/hdd/movie") == True) and (os.path.exists("/dev/ide/host0/bus0/target0/lun0") == True):
      # local harddisk found
      if os.path.exists("/media/hdd/MB_Images") == False:
         os.mkdir ("/media/hdd/MB_Images")
      try:
         os.symlink("/media/hdd/MB_Images","/MB_Images")
      except:
         pass
      barryallen_mbimagepath = "/media/hdd/MB_Images"
   else:
      # no local harddisk found
      if os.path.exists("/media/ba/MB_Images") == False:
         os.mkdir ("/media/ba/MB_Images")
      try:
         os.symlink("/media/ba/MB_Images","/MB_Images")
      except:
         pass
      barryallen_mbimagepath = "/media/ba/MB_Images"
      
# name of the imageinfofile
barryallen_infofile = "/.bainfo"

booted_image="Flash"
if os.path.exists(barryallen_infofile) == True:
   f = open(barryallen_infofile)
   booted_image = f.read()
   f.close()

###############################################################################
# Barry Allen Webinterface by gutemine
###############################################################################

class BarryAllenChild(resource.Resource):
    def __init__(self,session):
        self.session = session
        self.putChild('barryallen',BarryAllen())

class BarryAllen(resource.Resource):
    
    title = _("Barry Allen Webinterface by gutemine Version %s") % barryallen_version 
    title = title + ": %s" % booted_image
    
    def render(self, req):

        global baresult

        """ rendering server response """
        command = req.args.get("cmd",None)

        info_string=_("installed Images info")
        drivers_string=_("checking Image Driver Date")
        boot_string=_("select installed Image for booting")
        delete_string=_("delete installed Image")
        name_string=_("rename installed Image")
        copy_string=_("copy installed Image")
        image_mount_string=_("mount installed Image")
        image_umount_string=_("unmount installed Image")
        backup_nfi_string=_("backup  Image to nfi Image at /MB_Images")
        backup_bz2_string=_("backup  Image to tar.bz2 Image at /MB_Images")
        lock_string=_("switch Image lock")

        htmltasks = "<option value=\"info\">%s</option>" % info_string
        htmltasks += "<option value=\"boot\">%s</option>" % boot_string
        htmltasks += "<option value=\"delete\">%s</option>" % delete_string
        htmltasks += "<option value=\"name\">%s</option>" % name_string
        htmltasks += "<option value=\"copy\">%s</option>" % copy_string
        htmltasks += "<option value=\"copy\">%s</option>" % drivers_string
        f = open("/proc/cpuinfo")
        cputype = f.read()
        f.close()
        if cputype.find("XILLEON") is not -1:
           htmltasks += "<option value=\"image_mount\">%s</option>" % image_mount_string
           htmltasks += "<option value=\"image_umount\">%s</option>" % image_umount_string
        htmltasks += "<option value=\"backup_nfi\" class=\"green\">%s</option>" % backup_nfi_string
        htmltasks += "<option value=\"backup_bz2\" class=\"blue\">%s</option>" % backup_bz2_string

        htmlimages = "<option value=\"booted\">booted</option>"
        for name in os.listdir("/media/ba/ba"):
           if name.startswith(".") is False: 
              htmlimages += "<option value=\"%s\">%s</option>" % (name,name)
        if os.path.exists("/media/ba/ba/Flash") is False:    
           htmlimages += "<option value=\"Flash\" selected>Flash</option>"

        list_nfi_string=_("list nfi Images at /MB_Images")
        extract_nfi_string=_("extract nfi Image from /MB_Images")
        flash_nfi_string=_("flash nfi Image from /MB_Images")
        remove_nfi_string=_("remove nfi Image from /MB_Images")
        rename_nfi_string=_("rename nfi Image at /MB_Images")
        list_bz2_string=_("list tar.bz2 Images at /MB_Images")
        extract_bz2_string=_("extract tar.bz2 Image from /MB_Images")
        remove_bz2_string=_("remove tar.bz2 Image from /MB_Images")
        rename_bz2_string=_("rename tar.bz2 Image at /MB_Images")

        htmlnfitasks = "<option value=\"list_nfi\" class=\"green\">%s</option>" % list_nfi_string
        htmlnfitasks += "<option value=\"extract_nfi\" class=\"green\">%s</option>" % extract_nfi_string
#       htmlnfitasks += "<option value=\"flash_nfi\" class=\"green\">%s</option>" % flash_nfi_string
        htmlnfitasks += "<option value=\"rename_nfi\" class=\"green\">%s</option>" % rename_nfi_string
        htmlnfitasks += "<option value=\"remove_nfi\" class=\"green\">%s</option>" % remove_nfi_string
        htmlnfitasks += "<option value=\"list_bz2\" class=\"blue\">%s</option>" % list_bz2_string
        htmlnfitasks += "<option value=\"extract_bz2\" class=\"blue\"\">%s</option>" % extract_bz2_string
        htmlnfitasks += "<option value=\"rename_bz2\" class=\"blue\">%s</option>" % rename_bz2_string
        htmlnfitasks += "<option value=\"remove_bz2\" class=\"blue\">%s</option>" % remove_bz2_string

        htmlnfi = "<br>"
        sname = []
        bname = []
        if os.path.exists(barryallen_mbimagepath) == True:
           for name in os.listdir(barryallen_mbimagepath):
               if name.endswith(".nfi") is True: 
                  sname=name.split(".nfi")
                  htmlnfi += "<option value=\"%s\" class=\"green\">%s</option>" % (sname[0],sname[0])
               else:
                  if name.startswith("MB_") is True: 
                     sname=name.split("MB_")
                     bname=sname[1].split(".tar.bz2")
                     htmlnfi += "<option value=\"%s\" class=\"blue\">%s</option>" % (bname[0],bname[0])
               


        reboot_string=_("reboot Dreambox")
        webflash_string=_("enable WebIF flashing")
        halt_string=_("halt Dreambox")
        restart_string=_("restart %s on Dreambox")% enigma_version
        usbdriver_string=_("load USB drivers")
        passwd_string=_("copy passwd from Flash")
        automount_string=_("copy automount.conf")
        timercopy_string=_("copy timers.xml")
        timerlink_string=_("shared timers.xml")
#       epg_string=_("shared epg.dat")
        free_string=_("show memory")
        swapon_string=_("enable swapfile")
        swapoff_string=_("disable swapfile")
        ifconfig_string=_("ifconfig")
        netstat_string=_("netstat")
        language_string=_("display current language")
        flash_mount_string=_("mount Flash temporary")
        flash_umount_string=_("umount Flash when temporary mounted")
        flash_force_string=_("force Kernel and Drivers permanently onto Flash - use with care !")
        enable_squashfs_string=_("keep squashfs of OE 1.5 images")
        disable_squashfs_string=_("do not keep squashfs of OE 1.5 images")
        enable_bootmanager_string=_("enable bootmanager")
        disable_bootmanager_string=_("disable bootmanager")

        htmltools = "<option value=\"reboot\">%s</option>" % reboot_string
        htmltools += "<option value=\"halt\">%s</option>" %halt_string
        htmltools += "<option value=\"restart\">%s</option>" % restart_string
        htmltools += "<option value=\"webflash\">%s</option>" % webflash_string
#       htmltools += "<option value=\"usbdriver\">%s</option>" % usbdriver_string
        htmltools += "<option value=\"ifconfig\">%s</option>" % ifconfig_string
        htmltools += "<option value=\"netstat\">%s</option>" % netstat_string
#       htmltools += "<option value=\"passwd\">%s</option>" % passwd_string
#       htmltools += "<option value=\"automount\">%s</option>" % automount_string
#       htmltools += "<option value=\"timercopy\">%s</option>" % timercopy_string
#       htmltools += "<option value=\"timerlink\">%s</option>" % timerlink_string
#       htmltools += "<option value=\"epg\">%s</option>" % epg_string
        htmltools += "<option value=\"free\" selected>%s</option>" % free_string
        htmltools += "<option value=\"swapon\">%s</option>" % swapon_string
        htmltools += "<option value=\"swapoff\">%s</option>" % swapoff_string
        htmltools += "<option value=\"language\">%s</option>" % language_string
#       htmltools += "<option value=\"flash_force\">%s</option>" % flash_force_string
        if os.path.exists("/media/ba/.banobootmanager") == True:
           htmltools += "<option value=\"enable_bootmanager\">%s</option>" % enable_bootmanager_string
        else:
           htmltools += "<option value=\"disable_bootmanager\">%s</option>" % disable_bootmanager_string
        f = open("/proc/cpuinfo")
        cputype = f.read()
        f.close()
        if cputype.find("XILLEON") is not -1:
           if os.path.exists("/media/ba/.bakeepsquashfs") == False:
              htmltools += "<option value=\"enable_squashfs\">%s</option>" % enable_squashfs_string
           else:
              htmltools += "<option value=\"disable_squashfs\">%s</option>" % disable_squashfs_string

        htmluser = "<br>"
        for name in os.listdir(barryallen_usr_script):
           if name.endswith(".sh") is True: 
              htmluser += "<option value=\"%s/%s\">%s</option>" % (barryallen_usr_script,name,name)
        if os.path.exists(usr_script) == True:
           for name in os.listdir(usr_script):
              if name.endswith(".sh") is True: 
                 htmluser += "<option value=\"%s/%s\">%s</option>" % (usr_script,name,name)
               
        mainmenu_string=_("Barry Allen Main Menu")
        mainmenurefresh_string=_("Refresh Barry Allen Main Menu")
        header_string=_("Barry Allen Webinterface by gutemine Version %s") % barryallen_version
        header_string = header_string + ": %s" % booted_image
        notinstalled_string=_("Barry Allen is not installed")

        if command is None:

           if os.path.exists(barryallen_script) == False:
              html  = "<html><head><title>%s</title>" % self.title
              html += "<STYLE type=\"text/css\">"
              html += "OPTION.blue{background-color:white; color:blue}"
              html += "OPTION.green{background-color:white; color:green}"
              html += "</STYLE>"
              html += "</head><body bgcolor=\"red\">"
              html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
              html += "<font size=\"3 \" color=\"yellow\">"
              html += "\"%s\"" % notinstalled_string
              html += "</body></html>"
           else:
              html  = "<html><head><title>%s</title>" % self.title
              html += "<STYLE type=\"text/css\">"
              html += "OPTION.blue{background-color:white; color:blue}"
              html += "OPTION.green{background-color:white; color:green}"
              html += "</STYLE>"
              html += "</head><body bgcolor=\"red\">"
              html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
              html += "<font size=\"3 \" color=\"yellow\">"
              html += "<hr>"
              html += "%s" % header_string
              html += "<hr>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenurefresh_string
              html += "</select>"
              html += "</form>"
              html += "<hr>"

              wizardinstalled_string=_("Wizard for installed Images")
              execute_string=_("Execute")
              reset_string=_("Reset")
              html += "%s" % wizardinstalled_string
              html += "<form method=\"GET\">"
              html += "<select name=\"cmd\">"
              html += "%s" % htmltasks
              html += "</select>"
              html += "<select name=\"sourceimage\">"
              html += "%s" % htmlimages
	      html += "<input name=\"targetimage\" type=\"text\" size=\"60\" maxlength=\"60\">"
	      html += "<input name=\"pin\" type=\"text\" size=\"4\" maxlength=\"4\">"
	      html += "<br><br>"
              html += "<input type=\"submit\" size==\"100px\" value=\"%s\">" % execute_string
	      html += "<input type=\"reset\" size=\"100px\" value=\"%s\">" % reset_string
              html += "</form>"
              html += "<hr>"

              wizardmbimages_string=_("Wizard for Images at /MB_Images")
              html += "%s" % wizardmbimages_string
              html += "<form method=\"GET\">"
              html += "<select name=\"cmd\">"
              html += "%s" % htmlnfitasks
              html += "</select>"
              html += "<select name=\"sourceimage\">"
              html += "%s" % htmlnfi
	      html += "<input name=\"targetimage\" type=\"text\" size=\"60\" maxlength=\"60\">"
	      html += "<br><br>"
              html += "<input type=\"submit\" size==\"100px\" value=\"%s\">" % execute_string
	      html += "<input type=\"reset\" size=\"100px\" value=\"%s\">" %  reset_string
              html += "</form>"
              html += "<hr>"

              wizarddebian_string=_("Wizard for Debian")
              extract_debian_string=_("install Debian Linux")
              html += "%s" % wizarddebian_string
              html += "<form method=\"GET\">"
              html += "<select name=\"cmd\">"
              html += "<option value=\"extract_debian\">%s</option>" % extract_debian_string
              html += "</select>"
	      html += "<input name=\"sourceimage\" type=\"text\" size=\"60\" maxlength=\"60\">"
	      html += "<br><br>"
              html += "<input type=\"submit\" size==\"100px\" value=\"%s\">" % execute_string
	      html += "<input type=\"reset\" size=\"100px\" value=\"%s\">" %  reset_string
              html += "</form>"
              html += "<hr>"

              wizardtools_string=_("Wizard for Tools")
              html += "%s" % wizardtools_string
              html += "<form method=\"GET\">"
              html += "<select name=\"cmd\">"
              html += "%s" % htmltools
              html += "</select>"
              html += "<input type=\"submit\" size==\"100px\" value=\"%s\">" % execute_string
	      html += "<input type=\"reset\" size=\"100px\" value=\"%s\">" % reset_string
              html += "</form>"
              html += "<hr>"

              user_script_string=_("Execute User Script from /media/ba/script and /usr/script and userspecific option")
              html += "%s" % user_script_string
              html += "<form method=\"GET\">"
              html += "<select name=\"cmd\">"
              html += "%s" % htmluser
	      html += "<input name=\"arguments\" type=\"text\" size=\"60\" maxlength=\"60\">"
#	      html += "<br><br>"
              html += "<input type=\"submit\" size==\"100px\" value=\"%s\">" % execute_string
	      html += "<input type=\"reset\" size=\"100px\" value=\"%s\">" % reset_string
              html += "</form>"
              html += "<hr>"


              if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/WebChilds/Uploader.py.disabled") == True:
                 selected_string=_("selected") 
                 fileupload_string=_("Upload %s file to /MB_Images") % selected_string
                 html += "%s" % fileupload_string
                 html += "<form method=\"GET\">"
                 html += "<table cellPadding=0 cellSpacing=10>"
                 html += "<tr><td align=right>select File</td><td>&nbsp;&nbsp;<input type=file name=file value=\"\"></td></tr>"
                 html += "<input type=\"hidden\" name=\"cmd\" value=\"upload\">"
                 html += "<input type=\"submit\" value=\"%s\"></td></tr>" % execute_string
                 html += "</table>"
                 html += "</form>"
                 html += "</body>"
                 html += "</html>"
                 html += "<hr>"


              help_string=_("Help")
              readme_string=_("Barry Allen readme.txt")
              about_string=_("about Barry Allen Version %s") % barryallen_version
              html += "%s" % help_string
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"cmd\" value=\"readme\">"
              html += "<input type=\"submit\" value=\"%s\">" % readme_string
              html += "</select>"
              html += "</form>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"cmd\" value=\"about\">"
              html += "<input type=\"submit\" value=\"%s\">" % about_string
              html += "</select>"
              html += "</form>"
              html += "<hr>"


        elif command[0] ==  "upload":

           uploadfile = req.args.get("file",None)
           nameparts = []
           if uploadfile[0] is "":
              fileerror_string=_("ERROR: no file specified for Upload")
              html  = "<html><head><title>%s</title></head><body bgcolor=\"red\">" %self.title
              html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
              html += "<font size=\"3 \" color=\"yellow\">"
              html += "<hr>"
              html += "%s" % header_string
              html += "<hr>"
              html += "%s" % fileerror_string
              html += "<hr>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
              html += "</select>"
              html += "</form>"
              html += "<hr>"
              html += "</body>"
              html += "</html>"
           else:
              fileupload_string=_("Upload %s file to /MB_Images") % uploadfile[0]
              plugin_string=_("Barry Allen %s Plugin %s by gutemine") % (enigma_version, barryallen_version)
              html  = "<html><head><title>%s</title></head><body bgcolor=\"red\">" % plugin_string
              html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
              html += "<font size=\"3 \" color=\"yellow\">"
              html += "<hr>"
              html += "<a href=\"/upload?path='/MB_Images'&file='%s'\">%s</a><p>" % (uploadfile[0],fileupload_string)
              html += "<hr>"
              html += "</body>"
              html += "</html>"


        elif command[0] ==  "about":
              plugin_string=_("Barry Allen %s Plugin %s by gutemine") % (enigma_version, barryallen_version)
              kit_string=_("Barry Allen kit download from www.oozoon.de")
              docu_string=_("Thanks for the Documentation by romeo-golf")
              port_string=_("Thanks for supporting the PowerPC port:")
              port_names=_("cali.s, krallekit, adenin, Hein Holz")
              e1plugin_string=_("Thanks for the enigma1 plugin by DarkVolli")
              language_string=_("Thanks for the Language translations")
              language_string2=_("to all translators who are now named in readme.txt")

              html  = "<html><head><title>about %s</title></head><body bgcolor=\"red\">" %self.title
              html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
              html += "<font size=\"3 \" color=\"yellow\">"
              html += "<hr>"
              html += "%s" % plugin_string
              html += "<hr>"
              html += "%s" % kit_string
              html += "<hr>"
              html += "%s" % docu_string
              html += "<hr>"
              html += "%s" % port_string
              html += "<hr>"
              html += "%s" % port_names
              html += "<hr>"
              html += "%s" % e1plugin_string
              html += "<hr>"
              html += "%s" % language_string
              html += "<hr>"
              html += "%s" % language_string2
              html += "<hr>"
              html += "</body>"
              html += "</html>"

        elif command[0] == "result":

           return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=baresult)

        elif command[0] == "readme":

           if os.path.exists("%s/%s/LC_MESSAGES/readme.txt" % (barryallen_localedir,ba_language)) is True:
              balist = open("%s/%s/LC_MESSAGES/readme.txt" % (barryallen_localedir, ba_language),"r")
           else:
              balist = open(barryallen_readme,"r")
           html  = "<html><head><title>%s readme.txt</title></head><body bgcolor=\"red\">" %self.title
           html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
           html += "<font size=\"3 \" color=\"yellow\">"
           for name in balist:
              html += "%s" % name
              html += "<br>"
           balist.close()
           html += "</body></html>"

        elif command[0] == "reboot":

           rebooting_string=_("rebooting Dreambox now")
           html  = "<html><head><title>%s</title></head><body bgcolor=\"red\">" %self.title
           html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
           html += "<font size=\"3 \" color=\"yellow\">"
           html += "<hr>"
           html += "%s" % header_string
           html += "<hr>"
           html += "%s" % rebooting_string
           html += "<hr>"
           html += "</body></html>"
           os.system("reboot")

        else:

           arguments = req.args.get("arguments"," ")[0].rstrip()
           sourcename = req.args.get("sourceimage"," ")[0].rstrip()
           targetname = req.args.get("targetimage"," ")[0].rstrip()
           pin = req.args.get("pin"," ")[0].rstrip()

           executing_string=_("Barry Allen Version %s executing command %s") % (barryallen_version,command[0])
           html  = "<html><head><title>%s</title></head><body bgcolor=\"red\">" %self.title
           html += "<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
           html += "<font size=\"3 \" color=\"yellow\">"
           html += "<hr>"
           html += "%s" % executing_string
           html += "<hr>"
           html += "</body></html>"

           extract_string=_("extract will restart %s and also the Webserver")% enigma_version
           flash_string=_("flash will restart %s and also the Webserver")% enigma_version
           backup_string=_("backup will restart %s and also the Webserver")% enigma_version
           checkinfo_string=_("check result in Main Menu with info option in 3 min")
           checkinfo_list=_("check result in Main Menu with list option in 3 min")
           result_string=_("show command result")
           if command[0] == "extract_nfi":
              html += "%s" % extract_string
              html += "<hr>"
              html += "%s" % checkinfo_string
              html += "<hr>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
              html += "</select>"
              html += "</form>"
           elif command[0] == "flash_nfi":
              html += "%s" % flash_string
              html += "<hr>"
              html += "%s" % checkinfo_string
              html += "<hr>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
              html += "</select>"
              html += "</form>"
           elif command[0] == "backup":
              html += "%s" % backup_string
              html += "<hr>"
              html += "%s" % checkinfo_string
              html += "<hr>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
              html += "</select>"
              html += "</form>"
           else:
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"cmd\" value=\"result\">"
              html += "<input type=\"submit\" value=\"%s\">" %  result_string
              html += "</select>"
              html += "</form>"
              html += "<form method=\"GET\">"
              html += "<input type=\"hidden\" name=\"\">"
              html += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
              html += "</select>"
              html += "</form>"

           self.container = eConsoleAppContainer()
           try:
              self.container.appClosed.get().append(self.runFinished)
              self.container.dataAvail.get().append(self.dataAvail)
           except:
              self.container.appClosed.append(self.runFinished)
              self.container.dataAvail.append(self.dataAvail)
           if command[0].endswith(".sh") == True:
              if os.path.exists(command[0]) == True:
                 self.container.execute("%s %s" %(command[0],arguments))
              else:
                 # thanks 3c5x9 
                 self.container.execute("echo unsupported")
           else:
              self.container.execute("%s %s %s %s %s" %(barryallen_script,command[0],sourcename,targetname,pin))
              
           showing_result_string  = _("showing results of command")
           baresult  = "<html><head><title>%s %s %s</title></head><body bgcolor=\"red\">" %(self.title,showing_result_string,command[0])

        return http.Response(responsecode.OK, {'Content-type': http_headers.MimeType('text', 'html')},stream=html)
                
    def runFinished(self, retval):
        global baresult
        mainmenu_string=_("Barry Allen Main Menu")
        finished_string=_("Command finished")
#        baresult += "<hr>"
        baresult += "%s" % finished_string
        baresult += "<hr>"
        baresult += "<form method=\"GET\">"
        baresult += "<input type=\"hidden\" name=\"\">"
        baresult += "<input type=\"submit\" value=\"%s\">" % mainmenu_string
        baresult += "</select>"
        baresult += "</form>"
        baresult += "</body></html>"
        
			
    def dataAvail(self, str):
        global baresult
        if str[0] is "-":
           baresult += "<hr>"
        else:
           baresult += "%s\n" % str
           baresult += "<br>"
			

