#!/usr/bin/python 

# Originally by tmbinc, hacked to death by noggie
# and adapted for Barry Allen by gutemine
#

import sys, os, struct

if len(sys.argv) < 3:
	raise "please give NFI file and directory as arguments!"
	
if os.path.exists("/MB_Images/%s.nfi" % sys.argv[1]) is True:
   file = open("/MB_Images/%s.nfi" % sys.argv[1], "r")
   unpack = "/MB_Images"
elif os.path.exists("/media/ba/%s.nfi" % sys.argv[1]) is True:
   file = open("/media/ba/%s.nfi" % sys.argv[1], "r")
   unpack = "/media/ba"
else:
   raise "%s.nfi not found" % sys.argv[1]
   

directory = "/media/ba/ba/%s" % sys.argv[2]
header = file.read(32)

if header[:4] != "NFI1":
	print "old NFI format detected!"
	machine_type = "dm7020"
	file.seek(0)
else:
	machine_type = header[4:4+header[4:].find("\0")]

endianess = {"dm7025": "1234", "dm800": "1234", "dm8000": "1234", "dm7020": "4321", "dm600pvr": "4321", "dm500plus": "4321" }

print "machine type:", machine_type

(total_size, ) = struct.unpack("!L", file.read(4))

print "total_size:", total_size

p = 0
while file.tell() < total_size:
        (size, ) = struct.unpack("!L", file.read(4))
        print "partition_size:", size
	
	output_names = {2: "boot", 3: "root"}
	if p not in output_names:
		file.seek(size, 1)
	else:
		print "Extracting:", output_names[p], "..."
		output_filename = unpack + output_names[p];
		if p == 2:
			output_filename = "%s/boot.jffs2"  % unpack
		        output_directory = directory + "/" + output_names[p]
		if p == 3:
			output_filename = "%s/root.jffs2" % unpack
		        output_directory = directory 
		output = open(output_filename, "wb")
                if machine_type == "dm8000":
		    for sector in range(size / 2112):
			d = file.read(2112)
			output.write(d[:2048])
                else:
		    for sector in range(size / 528):
			d = file.read(528)
			output.write(d[:512])
		output.close()
		if p != 1:
		    if os.system("/media/ba/bin/nfidump --no-devtab --two-pass %s %s %s" % (output_filename, output_directory, endianess[machine_type])):
		       raise "unpacking jffs2 failed!"
		    print "ok"
#		    os.unlink(output_filename)
		
	p += 1

